<?php
// Sécurité
define('OK',1);
// Affichage des erreurs : à commenter en production
//ini_set('display_errors',1); error_reporting(E_ALL); ini_set('display_startup_errors',1);
// Configuration
include('config.php');
// Fonctions
include('fonctions.php');

////////////////////////////////////////////
// Validation de la requête : clé de page //
////////////////////////////////////////////

// Recherche de la page concernée, variable $page
// Si $_REQUEST['cle'] existe, on le cherche dans les pages disponibles.
// Si $_REQUEST['cle'] n'est pas trouvée, page d'accueil par défaut.
$mysqli = connectsql();
$resultat = $mysqli->query('SELECT p.id, CONCAT_WS(\'/\',m.cle,p.cle) AS cle,
                                   p.titre, p.bandeau, p.protection, p.mat, p.nom
                            FROM pages AS p LEFT JOIN matieres AS m ON p.mat = m.id ORDER BY p.mat,p.ordre');
if ( !empty($_REQUEST) )  {
  while ( $r = $resultat->fetch_assoc() )
    if ( isset($_REQUEST[$r['cle']]) )  {
      $page = $r;
      break;
    }
}
// Page par défaut : la première
if ( !isset($page) )  {
  // Si pas de page : installation nécessaire
  if ( !$resultat )  {
    include('installation.php');
    exit();
  }
  $resultat->data_seek(0);
  $page = $resultat->fetch_assoc();
}
$resultat->free();

/////////////////////////////
// Vérification de l'accès //
/////////////////////////////
// Interdiction de voir les pages de protection élevée ou non associées à ses
// propres matières si on est invité/élève/colleur
// Toutes les pages sont visibles pour les professeurs (édition : cf plus bas)
if ( $page['protection'] && ( $autorisation > 0 ) && ( $autorisation < 4 )
  && ( ( $page['protection'] > $autorisation ) || ( !in_array($page['mat'],explode(',',$_SESSION['matieres'])) ) ) )  {
  debut($mysqli,$page['titre'],'Vous n\'avez pas accès à cette page.',$autorisation,".?${page['cle']}");
  $mysqli->close();
  fin();
}
// Connexion nécessaire si protection
if ( $page['protection'] && !$autorisation )  {
  $titre = $page['titre'];
  $actuel = ".?${page['cle']}";
  include('login.php');
}
// Mode édition pour les professeurs sur leurs propres matières uniquement
$edition = ( ( $autorisation == 4 ) && in_array($page['mat'],explode(',',$_SESSION['matieres'])) );

//////////////
//// HTML ////
//////////////
debut($mysqli,$page['titre']. ( ( $edition && $page['protection'] ) ? "<span class=\"icon-lock${page['protection']}\"></span>" : '' ),$message,$autorisation,".?${page['cle']}",( $page['mat'] ) ? $page['mat'] : false);

// MathJax désactivé par défaut
$mathjax = false;

// Agenda éventuel
if ( $page['id'] == 1 )  {
  $resultat = $mysqli->query('SELECT val FROM prefs WHERE nom=\'nb_agenda_index\' OR nom=\'protection_agenda\' ORDER BY nom');
  $r = $resultat->fetch_row();
  $n = $r[0];
  $r = $resultat->fetch_row();
  $resultat->free();
  if ( $autorisation >= $r[0] )  {
    $resultat = $mysqli->query('SELECT m.nom AS matiere, t.nom AS type, texte,
                              DATE_FORMAT(debut,\'%w%Y%m%e\') AS d, DATE_FORMAT(fin,\'%w%Y%m%e\') AS f,
                              DATE_FORMAT(debut,\'%kh%i\') AS hd, DATE_FORMAT(fin,\'%kh%i\') AS hf
                              FROM agenda AS a JOIN `agenda-types` AS t ON a.type = t.id LEFT JOIN matieres AS m ON a.matiere = m.id
                              WHERE CURDATE() <= DATE(fin) AND ADDDATE(CURDATE(),7) >= DATE(debut) ORDER BY debut,fin LIMIT '.$n);
    if ( $resultat->num_rows )  {
      echo "\n  <h2><a href=\"agenda\" title=\"Afficher l'agenda du mois\" style=\"text-decoration: none;\"><span class=\"icon-agenda\"></span></a>&nbsp;Prochains événements</h2>\n\n  <article>";
      while ( $r = $resultat->fetch_assoc() )  {
        // Événement sur un seul jour
        if ( ( $d = $r['d'] ) == ( $f = $r['f'] ) )  {
          $date = substr(ucfirst(format_date($d)),0,-5);
          if ( ( $hd = $r['hd'] ) != '0h00' )
            $date .= ( $hd == $r['hf'] ) ? ' à '.str_replace('00','',$hd) : ' de '.str_replace('00','',$hd).' à '.str_replace('00','',$r['hf']);
        }
        // Événement sur plusieurs jours
        else  {
          if ( ( $hd = $r['hd'] ) == '0h00' )
            $date = 'Du '.substr(format_date($d),0,-5).' au '.substr(format_date($f),0,-5);
          else
            $date = 'Du '.substr(format_date($d),0,-5).' à '.str_replace('00','',$r['hd']).' au '.substr(format_date($f),0,-5).' à '.str_replace('00','',$r['hf']);
        }
        $titre = ( strlen($r['matiere']) ) ? "${r['type']} en ${r['matiere']}" : $r['type'];
        echo "\n  <h3>$date&nbsp;: $titre</h3>\n";
        if ( strlen($r['texte']) )
          echo "  <p>${r['texte']}</p>\n";
      }
      $resultat->free();
      echo "  </article>\n\n";
    }
  }
}

// Affichage public sans édition
if ( !$edition )  {
  // Affichage des informations diffusées
  $resultat = $mysqli->query("SELECT IF(LENGTH(titre),CONCAT('<h3>',titre,'</h3>'),'') AS titre, texte FROM infos WHERE page = ${page['id']} AND cache = 0");
  if ( $resultat->num_rows )  {
    if ( strlen($page['bandeau']) )
      echo "\n  <h2>${page['bandeau']}</h2>\n";
    while ( $r = $resultat->fetch_assoc() )  {
      $mathjax = ( $mathjax ) ? true : strpos($r['texte'],'$')+strpos($r['texte'],'\\');
      echo <<<FIN

  <article>
    ${r['titre']}
${r['texte']}
  </article>

FIN;
    }
    $resultat->free();
  }
  else
    echo "  <article><h3>Cette page est actuellement vide.</h3></article>\n\n";
}

// Affichage professeur éditeur
else  {
  echo <<<FIN

  <a class="icon-aide general" data-id="page" title="Aide pour les modifications de cette page"></a>
  <a class="icon-prefs general" data-id="prefs" title="Modifier les préférences de cette page"></a>
  <a class="icon-ajoute general" data-id="ajoute" title="Ajouter une nouvelle information"></a>

FIN;
  if ( strlen($page['bandeau']) )
    echo "  <h2 class=\"edition\">${page['bandeau']}&nbsp;</h2>\n";

  // Affichage des informations diffusées
  $resultat = $mysqli->query("SELECT id, ordre, cache, titre, texte FROM infos WHERE page = ${page['id']}");
  if ( $max = $resultat->num_rows )  {
    while ( $r = $resultat->fetch_assoc() )  {
      $mathjax = ( $mathjax ) ? true : strpos($r['texte'],'$')+strpos($r['texte'],'\\');
      if ( $r['cache'] )  {
        $classe_cache = ' class="cache"';
        $visible = '<a class="icon-montre" title="Afficher l\'information sur la partie publique"></a>
    <a class="icon-cache" style="display:none;" title="Rendre invisible l\'information sur la partie publique"></a>';
      }
      else  {
        $classe_cache = '';
        $visible = '<a class="icon-montre" style="display:none;" title="Afficher l\'information sur la partie publique"></a>
    <a class="icon-cache" title="Rendre invisible l\'information sur la partie publique"></a>';
      }
      $monte = ( $r['ordre'] == 1 ) ? ' style="display:none;"' : '';
      $descend = ( $r['ordre'] == $max ) ? ' style="display:none;"' : '';
      echo <<<FIN

  <article$classe_cache data-id="infos|${r['id']}">
    <a class="icon-aide" data-id="information" title="Aide pour l'édition de cette information"></a>
    $visible
    <a class="icon-monte"$monte title="Déplacer cette information vers le haut"></a>
    <a class="icon-descend"$descend title="Déplacer cette information vers le bas"></a>
    <a class="icon-supprime" title="Supprimer cette information"></a>
    <h3 class="edition editable" data-id="infos|titre|${r['id']}" data-placeholder="Titre de l'information (non obligatoire)">${r['titre']}</h3>
    <div class="editable edithtml" data-id="infos|texte|${r['id']}" data-placeholder="Texte de l'information (obligatoire)">
${r['texte']}
    </div>
  </article>

FIN;
    }
    $resultat->free();
  }
  else
    echo "  <article><h2>Cette page est actuellement vide.</h2></article>\n\n";

  // Select sur la protection
  $select_protection = str_replace("\"${page['protection']}\"","\"${page['protection']}\" selected",'
      <option value="0">Visible de tous</option>
      <option value="1">Visible pour les connectés</option>
      <option value="2">Visible pour les élèves, colleurs, profs</option>
      <option value="3">Visible pour les colleurs et les profs</option>
      <option value="4">Visible pour les profs uniquement</option>
      <option value="5">Non visible</option>');

  // Aide et formulaires d'ajout d'information, de préférences de page
?>

  <form id="form-ajoute">
    <h3 class="edition">Ajouter une nouvelle information</h3>
    <div>
      <input class="ligne" type="text" name="titre" size=50 data-placeholder="Titre de l'information (non obligatoire)">
      <textarea name="texte" class="edithtml" rows="10" cols="100" data-placeholder="Texte de l'information (obligatoire)"></textarea>
      <p class="ligne"><label for="cache">Ne pas diffuser sur la partie publique&nbsp;: </label><input type="checkbox" id="cache" name="cache" value="1"></p>
    </div>
    <input type="hidden" name="page" value="<?php echo $page['id']; ?>">
    <input type="hidden" name="table" value="infos">
  </form>

  <form id="form-prefs">
    <h3 class="edition">Modifier les préférences de la page</h3>
    <p class="ligne"><label for="titre">Titre&nbsp;: </label><input type="text" id="titre" name="titre" value="<?php echo $page['titre']; ?>" size="80" data-placeholder="Titre de la page (obligatoire)"></p>
    <p class="ligne"><label for="nom">Nom dans le menu&nbsp;: </label><input type="text" id="nom" name="nom" value="<?php echo $page['nom']; ?>" size="50" data-placeholder="Nom de la page dans le menu (obligatoire)"></p>
    <p class="ligne"><label for="cle">Clé dans l'adresse&nbsp;: </label><input type="text" id="cle" name="cle" value="<?php echo ($p = strpos($page['cle'],'/'))?substr($page['cle'],$p+1):$page['cle']; ?>" size="30" data-placeholder="Mot-clé sans majuscule, sans accent, sans espace (obligatoire)"></p>
    <p class="ligne"><label for="bandeau">Texte de début&nbsp;:</label></p>
    <textarea id="bandeau" name="bandeau" rows="2" cols="100" data-placeholder="Texte apparaissant au début de la page (non obligatoire)"><?php echo $page['bandeau']; ?></textarea>
    <p class="ligne"><label for="protection">Accès&nbsp;: </label>
      <select id="protection" name="protection"><?php echo $select_protection; ?>
      </select>
    </p>
    <input type="hidden" name="id" value="<?php echo $page['id']; ?>">
    <input type="hidden" name="table" value="pages">
  </form>

  <div id="aide-page">
    <h3>Aide et explications</h3>
    <p>Il est possible ici d'ajouter une information, de modifier les informations existantes ou de modifier les préférences de la page.</p>
    <p>Pour déplacer cette page d'information, la supprimer, la vider de son contenu ou en créer d'autres, il faut aller à la <a href="pages">gestion des pages</a>.</p>
    <p>Les informations dans chaque zone indiquée par des pointillés sont modifiables individuellement, en cliquant sur les boutons <span class="icon-edite"></span> et en validant avec le bouton <span class="icon-ok"></span> qui apparaît alors.</p>
    <p>Les deux boutons généraux permettent de&nbsp;:</p>
    <ul>
      <li><span class="icon-ajoute"></span>&nbsp;: ouvrir un formulaire pour ajouter une nouvelle information.</li>
      <li><span class="icon-prefs"></span>&nbsp;: ouvrir un formulaire pour modifier les préférences de la page.</li>
    </ul>
    <h4>Préférences associées à cette page</h4>
    <p>Concernant cette page, vous pouvez modifier&nbsp;:</p>
    <ul>
      <li>le <em>titre</em> qui sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos du TIPE&nbsp;».</li>
      <li>le <em>nom dans le menu</em> qui est affiché dans le menu en tant que lien vers la page. Il est préférable qu'il rentre sur une ligne, il faut donc le choisir assez court. Par exemple, «&nbsp;Informations TIPE&nbsp;».</li>
      <li>la <em>clé dans l'adresse</em> qui est un mot-clé utilisé uniquement dans l'adresse de la page. Par convention, il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;tipe&nbsp;». La clé doit obligatoirement être unique (deux pages ne peuvent pas avoir la même clé).</li>
      <li>l'<em>accès</em> à la page (voir ci-dessous).</li>
      <li>le <em>texte de début</em> qui sera affiché au-dessus des informations de la page. Il s'agit d'une ou deux phrases maximum. Il n'est affiché que si la page contient des informations. Cette case peut être laissée vide.</li>
    </ul>
    <p>L'<em>accès</em> à chaque page peut être choisi parmi six possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (utilisateurs de type invité, élève, colleur ou professeur). Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type élève, colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Non visible</em>&nbsp;: entièrement invisible pour les utilisateurs autres que les professeurs (éventuellement associés à la matière dont la page peut dépendre). La différence avec le choix précédent est que cette page n'apparaît plus du tout dans le menu pour ceux qui ne la voient pas.</li>
    </ul>
    <p>Hormis le dernier choix, le lien dans le menu apparaîtra pour tout visiteur (identifié ou non). Le niveau de protection est indiqué dans le titre par une icône de type <span class="icon-lock1"></span> où le numéro correspond au niveau de protection.</p>
    <p>Les comptes utilisateurs sont à définir ou modifier sur la page de <a href="utilisateurs">gestion des utilisateurs</a>. Les associations avec les matières sont modifiables sur la page de <a href="matieres">gestion des matières</a>.</p>
    <h4>Autres modifications de la page</h4>
    <p>Il est aussi possible de modifier, sur la page de <a href="pages">gestion des pages</a>, la matière associée à la page. Une page sans matière apparaît en haut du menu, une page avec matière associée apparaît dans le menu au niveau de la matière. Elle n'est alors visible que par les utilisateurs associés à la matière, modifiable que par les professeurs associés à la matière. Pour modifier les matières qui vous sont associées, il faut aller sur la page de <a href="matieres">gestion des matières</a>.</p>
    <p>Il est aussi possible de supprimer toutes les informations d'une page (sans supprimer la page elle-même), ou de supprimer la page elle-même, sur la page de <a href="pages">gestion des pages</a>.</p>
  </div>

  <div id="aide-information">
    <h3>Aide et explications</h3>
    <p>Le titre et le texte de chaque information sont modifiables séparément, en cliquant sur le bouton <span class="icon-edite"></span> correspondant. Chaque contenu éditable est indiqué par une bordure en pointillés.</p>
    <p>Une fois le texte édité, il est validé en appuyant sur Entrée dans le cas des titres ou sur le bouton <span class="icon-ok"></span>. Au contraire, un clic sur le bouton <span class="icon-annule"></span> annule l'édition.</p>
    <p>Le titre d'une information peut rester vide.</p>
    <p>D'autres modifications sont possibles à l'aide des boutons disponibles pour chaque information&nbsp;:</p>
    <ul>
      <li><span class="icon-supprime"></span>&nbsp;: supprimer l'information (une confirmation sera demandée)</li>
      <li><span class="icon-monte"></span>&nbsp;: remonter l'information d'un cran</li>
      <li><span class="icon-descend"></span>&nbsp;: descendre l'information d'un cran</li>
      <li><span class="icon-cache"></span>&nbsp;: rendre l'information non visible sur la partie publique. Cela peut être utile pour une information qui n'est plus valable mais que l'on souhaite réutiliser, ou pour une information rédigée en avance dans le but d'une publication ultérieure.</li>
      <li><span class="icon-montre"></span>&nbsp;: afficher l'information sur la partie publique</li>
    </ul>
    <p>Le texte doit être formaté en HTML&nbsp;: par exemple, chaque bloc de texte doit être encadré par &lt;p&gt; et &lt;/p&gt;. Il peut donc contenir des liens vers les autres pages du site, vers des documents du site, vers le web... Des boutons sont fournis pour aider au formatage (ainsi qu'une aide).</p>
  </div>

  <div id="aide-ajoute">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de créer une nouvelle information. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>.</p>
    <p>Le <em>titre</em> sera affiché, un peu plus gros, au-dessus de l'information. Ce doit être un simple texte. Il peut rester vide (il n'y aura alors pas de titre affiché).</p>
    <p>Le <em>texte</em> doit être formaté en HTML. Par exemple, chaque bloc de texte doit être encadré par &lt;p&gt; et &lt;/p&gt; (paragraphe). Il peut donc contenir des liens vers les autres pages du site, vers des documents du site, vers le web... Des boutons sont fournis pour aider au formatage.</p>
    <p>La case à cocher <em>Ne pas diffuser sur la partie publique</em> permet de cacher temporairement cette information, par exemple pour la diffuser ultérieurement. Si la case est cochée, l'information ne sera pas diffusée et pourra être affichée à l'aide du bouton <span class="icon-montre"></span>. Si la case est décochée, l'information sera immédiatement visible et pourra être rendue invisible à l'aide du bouton <span class="icon-cache"></span>.</p>
    <p>L'information sera affichée en haut de page, mais pourra être déplacée ultérieurement à l'aide des boutons <span class="icon-descend"></span> et <span class="icon-monte"></span>.</p>
  </div>

  <div id="aide-prefs">
    <h3>Aide et explications</h3>
    <p>Ce formulaire permet de modifier les préférences de cette page d'informations. Il sera validé par un clic sur <span class="icon-ok"></span>, et abandonné (donc supprimé) par un clic sur <span class="icon-ferme"></span>. On peut y modifier&nbsp;:</p>
    <ul>
      <li>le <em>titre</em> qui sera affiché en haut de page et dans la barre de titre du navigateur. Par exemple, «&nbsp;À propos de l'ADS et du TIPE&nbsp;».</li>
      <li>le <em>nom dans le menu</em> qui est affiché dans le menu en tant que lien vers la page. Il est préférable qu'il rentre sur une ligne, il faut donc le choisir assez court. Par exemple, «&nbsp;Informations ADS/TIPE&nbsp;».</li>
      <li>la <em>clé dans l'adresse</em> qui est un mot-clé qui est utilisé uniquement dans l'adresse de la page. Par convention, il vaut mieux que ce soit un mot unique, court et sans majuscule. Par exemple, «&nbsp;ads-tipe&nbsp;». La clé doit obligatoirement être unique (deux pages ne peuvent pas avoir la même clé).</li>
      <li>le <em>texte de début</em>, qui sera affiché au-dessus des informations de la page. Il s'agit d'une ou deux phrases maximum. Il n'est affiché que si la page contient des informations. Cette case peut être laissée vide.</li>
      <li>l'<em>accès</em> à la page (voir ci-dessous).</li>
    </ul>
    <p>Il est aussi possible de modifier sur la page de <a href="pages">gestion des pages</a> la matière associée à la page. Une page sans matière apparaît en haut du menu, une page avec matière associée apparaît dans le menu au niveau de la matière. Elle n'est alors visible que par les utilisateurs associés à la matière, modifiable que par les professeurs associés à la matière. Pour modifier les matières qui vous sont associées, il faut aller sur la page de <a href="matieres">gestion des matières</a>.</p>
    <p>L'<em>accès</em> à cette page peut être choisi parmi six possibilités&nbsp;:</p>
    <ul>
      <li><em>Visible de tous</em>&nbsp;: accessible de tout visiteur, sans identification.</li>
      <li><em>Visible pour les connectés</em>&nbsp;: accessible de tout utilisateur mais uniquement après identification (utilisateurs de type invité, élève, colleur ou professeur). Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les élèves, colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type élève, colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les colleurs, professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type colleur ou professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Visible pour les professeurs</em>&nbsp;: accessible uniquement par les utilisateurs de type professeur. Pour les pages associées à une matière, seuls les utilisateurs associés à cette matière ou à toutes les matières peuvent y accéder.</li>
      <li><em>Non visible</em>&nbsp;: entièrement invisible pour les utilisateurs autres que les professeurs (éventuellement associés à la matière dont la page peut dépendre). La différence avec le choix précédent est que cette page n'apparaît plus du tout dans le menu pour ceux qui ne la voient pas.</li>
    </ul>
    <p>Hormis le dernier choix, le lien dans le menu apparaîtra pour tout visiteur (identifié ou non). Le niveau de protection est indiqué dans le titre par une icône de type <span class="icon-lock1"></span> où le numéro correspond au niveau de protection.</p>
    <p>Les comptes utilisateurs sont à définir ou modifier sur la page de <a href="utilisateurs">gestion des utilisateurs</a>. Les associations avec les matières sont modifiables sur la page de <a href="matieres">gestion des matières</a>.</p>
  </div>

  <p id="log"></p>
<?php
}

$mysqli->close();
fin($edition,$mathjax);
?>
